import java.net.*;
import java.io.*;
import java.util.*;


///////////////////////////////////////////////////////////////////////////////
// 
// StatVector with bounded size
//
///////////////////////////////////////////////////////////////////////////////
final class BoundStatVector extends StatVector
{
    // constructor ============================================================
    BoundStatVector( int size )
    {
        sizeBound_ = size;
    }

    // disable default constructor ============================================
    private BoundStatVector()
    {
        ; // intentionally left blank 
    }

    // add double and check for bound =========================================
    synchronized void addDouble( double elem ) 
    {
      // vector full?
      if ( size() == sizeBound_ ) {
          removeElement( firstElement() );
      }

      super.addDouble( elem );
    }

    private int sizeBound_ = 0;
}
