import java.net.*;
import java.io.*;
import java.util.*;


///////////////////////////////////////////////////////////////////////////////
// 
// Timed network service
//
///////////////////////////////////////////////////////////////////////////////
final class Net
{
    // retrieves a given url and returns statistics ===========================
    static Stat1 getDoc( String url, Webpp parent )
    {
        String locURL = null;
        Stat1 stat = new Stat1();
        URL doc;
        InputStream in;
        Timer lat = new Timer();
        String cont;
	long tnet0, tnet1, textract0, textract1;	// Mehmet: measure times
	URLConnection conn = null;		// Mehmet: moved declaration here
        
        
        if ( NO_NETWORK ) {
            stat.lat  = rnd.nextDouble();
            stat.tot  = stat.lat + rnd.nextDouble() / 3.;
            stat.band = 0.;

            return stat;
        }

        try {           
            // must re-enable priviledges to use them in this method
            if( Webpp.browser == Webpp.NAVIGATOR ){
                //netscape.security.PrivilegeManager.enablePrivilege( 
                //                                     "UniversalFileRead" );
                //netscape.security.PrivilegeManager.enablePrivilege( 
                //                                     "UniversalFileWrite" );
                //netscape.security.PrivilegeManager.enablePrivilege( 
                //                                     "UniversalConnect" );
		netscape.security.PrivilegeManager.enablePrivilege(
							"Netcaster");
		//netscape.security.PrivilegeManager.enablePrivilege(
		//					"UniversalFileAccess");
		//netscape.security.PrivilegeManager.enablePrivilege(
		//					"Account Setup");
            } else {
                com.ms.security.PolicyEngine.assertPermission( 
                                      com.ms.security.PermissionID.FILEIO );
                com.ms.security.PolicyEngine.assertPermission( 
                                      com.ms.security.PermissionID.NETIO );
            }
        } catch( Exception e ){
            Assert.assert( false, "getDoc: security enb " + e.getMessage() );
        }            

	// Begin Mehmet: added these to see if the parent doc is in client cache
	String docname = url;
	int i = url.indexOf("webppserv.Webpp") + 16;
	int j = docname.indexOf('?');
	if (j < i) j = -1;	// this shouldn't happen, but checking just in case
        if (i != -1 && j==-1) docname = url.substring(i);
	if (i != -1 && j != -1) docname = url.substring(i, j);
	docname = docname.replace( '/', '-' );
	//System.out.println("Docname: " + docname);
	if (Webpp.cache.inCache(docname)) {
	  Webpp.ClientHasParentDoc = true;
	  if (url.indexOf('?') != -1) url += "parent;";
	  else url += "?;parent;";
	  locURL = Webpp.baseDir + docname;
	}
	else {
	  Webpp.ClientHasParentDoc = false;
	}
	// End Mehmet


	// Begin Mehmet: get the resp time of the last request to that server and add it to QueryString (embStr)
	if (Webpp.prevResponseTime != null) {
	  Webpp.prevResponseTime = "|" + Webpp.prevResponseTime + "|";
	  if (url.indexOf('?') != -1) url += Webpp.prevResponseTime;
	  else url += "?" + Webpp.prevResponseTime;
	}
	// End Mehmet

	tnet0 = System.currentTimeMillis();	// Mehmet: measure times
        
        try {
            doc = new URL( url );
        } catch( Exception e ){
            System.out.println( "getDoc: URL create " + e.getMessage() );
            return null;
        }           
        
        try {
            // setup connection
            lat.start();
            conn = doc.openConnection();	// Mehmet: moved declaration of conn to the beginning of this function

	    // Begin Mehmet: added these to set a request header when the parent doc is in client cache
	    if (Webpp.ClientHasParentDoc) {
		//conn.setDefaultRequestProperty("ClientHasParentDoc","yes");
		conn.setRequestProperty("ClientHasParentDoc","yes");
	    }
	    else {
		//conn.setDefaultRequestProperty("ClientHasParentDoc","no");
		conn.setRequestProperty("ClientHasParentDoc","no");
	    }
	    // End Mehmet
            conn.setUseCaches( false );
	    //conn.connect();	// Mehmet: added this

            cont = conn.getContentType();
            in = conn.getInputStream();

	    // Begin Mehmet: debug headers
	    //String tmp = conn.getHeaderField("TestHeader");
	    //if (tmp != null) System.out.println("TestHeader: " + tmp);
	    //else System.out.println("TestHeader: null");
	    // Mehmet: get ServerList from headers if available.
	    String serverList = conn.getHeaderField("ServerList");
	    if (serverList != null) {
	      System.out.println("Received ServerList: " + serverList);
	      parent.findHostServer(serverList, parent);
	    }
	    // End Mehmet
            
            lat.stop();   // had to get first byte to access MIME header
            stat.lat = (double)(lat.getTime()) / 1000.;
            
        } catch( Exception e ){
            System.out.println( "getDoc: in stream open " + e.getMessage() );
            return null;
        }

	tnet1 = System.currentTimeMillis() - tnet0;	// Mehmet: measure times
	System.out.println("Network Connection time: " + tnet1);	// Mehmet: measure times
        
	textract0 = System.currentTimeMillis();		// Mehmet: measure times
        // extract documents from the network
        try {
	    if (Webpp.ClientHasParentDoc) extractDocs( in, stat );	// Mehmet: added if-else here
            else locURL = extractDocs( in, stat );		// 	instead of locURL = extractDocs( in, stat );
        } catch( Exception e ){
            System.out.println( "getDoc: in extractDocs " + e.getMessage() );
            return null;
        }
	textract1 = System.currentTimeMillis() - textract0;	// Mehmet: measure times
	System.out.println("Extract function time: " + textract1);	// Mehmet: measure times
        stat.locURL = patchPath( locURL );
        
        try {
            in.close();
        } catch( Exception e ){
            System.out.println( "getDoc: conn close " + e.getMessage() );
            return null;
        }

        return stat;
    }

    // retrieves a given url and returns statistics ===========================
    static Stat1 getSample( String url )
    {
        String cont;
        InputStream in;
        Stat1 stat = new Stat1();
        Timer lat  = new Timer();

        if ( NO_NETWORK ) {
            stat.lat  = rnd.nextDouble();
            stat.tot  = 0.;
            stat.band = 0.;

            return stat;
        }
        
        // must re-enable priviledges to use them in this method
        if( Webpp.browser == Webpp.NAVIGATOR ){
            netscape.security.PrivilegeManager.enablePrivilege( 
                                  "UniversalConnect" );
        } else {
            com.ms.security.PolicyEngine.assertPermission( 
                                  com.ms.security.PermissionID.NETIO );
        }
            
        try {
            URL doc = new URL( url );

	        lat.start();

            // setup connection
            URLConnection conn = doc.openConnection();
            conn.setUseCaches( false );
 
            // get Content-Type MIME header to make sure that at least 1 byte
            // has been received
            cont = conn.getContentType();
            if( cont == null ){
                return null;
            }
            
            in = conn.getInputStream();
            if( in == null ){
                return null;
            }
                        
            // measure latency
            lat.stop();

            stat.size = 0;
            stat.lat  = (double)(lat.getTime()) / 1000.;
            stat.tot  = 0.;
            stat.band = 0.;
        } 

        catch (Exception e) {
            return null;
        }

        return stat;
    }
    
    // extracts documents from a multipart message ==========================
    // FIXME: at some point this should follow the MIME rules
    protected static String extractDocs( InputStream inStrm, Stat1 stat )
        throws IOException
    {
        BufferedInputStream bInStrm; 
        byte buf[] = new byte[HUGE_BUF_LEN];
        byte newBuf[];
        byte tmpBuf[];
        BufferedOutputStream outStrm = null;
        int bytesRead;
        int totalRead = 0;
        String fileName = null;     
        int i;
	Timer tot  = new Timer();
        String base;
        Stack end = new Stack();
	long tnet0, tnet1, textract0, textract1;	// Mehmet: measure time
        
        
        // start response time timer
        tot.start();

	tnet0 = System.currentTimeMillis();	// Mehmet: measure time
        
        bInStrm = new BufferedInputStream( inStrm );
        while( (bytesRead = bInStrm.read( buf, totalRead, buf.length-totalRead)) 
               != -1 ){
            totalRead += bytesRead;
            
            if( totalRead >= buf.length ){
                // once starts filling up, increase size of buffer
                newBuf = new byte[buf.length + Webpp.BUF_LEN];
                System.arraycopy( buf, 0, newBuf, 0, totalRead );
                buf = newBuf;
            }           
        }
	tnet1 = System.currentTimeMillis() - tnet0;	// Mehmet: measure time
        
        tot.stop();                              // stop response time timer

	System.out.println("Bytes read: " + totalRead);	// Mehmet: debug

        // update statistics
        stat.size   = totalRead;
        stat.tot    = (double)(tot.getTime()) / 1000.;
        if( stat.tot == stat.lat ){
            stat.band = 0.;
        } else {
            stat.band   = (double)stat.size / (stat.tot - stat.lat);
        }

	textract0 = System.currentTimeMillis();	// Mehmet: measure time

        // extract and store files
        for( i = 0; i < totalRead; i++ ){
            if( i < buf.length - separatorB.length &&
                match( buf, i, separatorB ) ){

		String fname = getFileName( buf, i+separatorB.length, end );	// Mehmet: added this
                    
                fileName = Webpp.baseDir + fname;	// Mehmet: replaced getFileName() call with fname variable

		Webpp.cache.putCache(fname);	// Mehmet: added this to insert new filenames to cache index
                                
                if( outStrm != null ){
                    outStrm.close();
                }

                outStrm = new BufferedOutputStream( new FileOutputStream( 
                                                  fileName ));
 
                if( fileName.indexOf( "html" ) != -1 ){
                    // add a base statement into the 
                    // FIXME: we should be more selective when to inject this 
                    //        clause (eg it should not be injected if the emb.
                    //        resources are to be fetched over the net from 
                    //        another server) 
                    base = "<BASE HREF=\"" + patchPath(Webpp.baseDir) + 
                           "\">\n";
                    tmpBuf  = base.getBytes();
                    outStrm.write( tmpBuf, 0, tmpBuf.length );
                }
                
                // skip over the rest of separator
                i = ( (Integer) end.pop() ).intValue();

            } else {
	            // just copy bytes to a file if any open 
	            if( outStrm != null ){
                    outStrm.write( buf[i] );
                }
            }
        }

        if( outStrm != null ){
            outStrm.close();
        }

	textract1 = System.currentTimeMillis() - textract0;	// Mehmet: measure time
	System.out.println("Network Transfer time: " + tnet1);	// Mehmet: measure time
	System.out.println("Extraction time: " + textract1);	// Mehmet: measure time

        return fileName; 
    }
    
    // ========================================================================
    protected static boolean match( byte buf[], int pos, byte sep[] )
    {
        int i;

        for( i = 0; i < sep.length; i++ ){
	        if( buf[pos+i] != sep[i] ){
                return false;
            }
        }

        return true;
    }

    // ========================================================================
    protected static String getFileName( byte buf[], int pos, Stack end )
    {
        int i;
        StringBuffer fileName = new StringBuffer();
        byte endString[] = new String( ">" ).getBytes();
        String tmpChar;

        Assert.assert( end.empty() );

        for( i = pos; i < buf.length; i++ ){
	        if( match( buf, i, endString ) ){
                end.push( new Integer(i) );
                return fileName.toString().replace( '/', '-' );
            }

            tmpChar = new String( buf, i, 1 );
            fileName.append(tmpChar);
        }

        return null;
    }
    
    // extracts documents from a multipart message ==========================
    protected static String patchPath( String path )
    {
        path = "file:" + path;   
        
        if ( Webpp.os == Webpp.WIN ) {
            // HACK: we should write a generic string 
            // replacement routine to do this job
            // file:C:\Temp\file.html -> file:///C|/Temp/file.html
            path = path.replace( '\\', '/' );
            path = "file:///C|" + path.substring(7, path.length());
        }
        
        return path;
    }

    // package data members ===================================================
    static Random rnd;

    // package private data members ===========================================
    protected static String baseDir;

    // private constants ======================================================
    protected static final boolean NO_NETWORK = false;
    protected static final int HUGE_BUF_LEN = 307200;
    protected static final String separator = new String( "<WEBPP_APPEND " );
    protected static final byte separatorB[] = separator.getBytes();
    
    // class constructor ======================================================
    static 
    {
        rnd    = new Random();
        //cache = new Cache();	// Mehmet: added this, later moved to Webpp class
        
        if ( Webpp.os == Webpp.UNIX ) {
            Webpp.baseDir = new String( "/tmp/" );
        } else {
            Webpp.baseDir = new String( "C:\\TEMP\\" );
        }    
    }
}

/*
abstract class MyURLConnection extends URLConnection {
  //MyURLConnection() { super(); }
  MyURLConnection(URL url) { super(url); }
  void setURL(URL newURL) { url = newURL; }
}
*/